



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>python定义类()中写object和不写的区别</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">python定义类()中写object和不写的区别</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 11:05:57 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>这里需要说明一下：</p>
<ul><li><p>python3中，类定义默认继承object，所以写不写没有区别</p></li>
<li><p>但在python2中，并不是这样</p></li></ul>
<p>所以此内容是针对python2的，当然python3默认继承，不代表我们就傻乎乎的让程序自动继承，自己却不知道其底层区别，所以了解此内容还是很有必要的！</p>
<p>测试代码如下：</p>
<pre class="prettyprint linenums"><code># -.- coding:utf-8 -.-<br />
# __author__ = 'zhengtong'

class Person:<br />
    &quot;&quot;&quot;<br />
    不带object<br />
    &quot;&quot;&quot;<br />
    name = &quot;zhengtong&quot;

class Animal(object):<br />
    &quot;&quot;&quot;<br />
    带有object<br />
    &quot;&quot;&quot;<br />
    name = &quot;chonghong&quot;

if __name__ == &quot;__main__&quot;:<br />
    x = Person()<br />
    print &quot;Person&quot;, dir(x)

    y = Animal()<br />
    print &quot;Animal&quot;, dir(y)<br />
</code></pre>
<p>输出如下：</p>
<pre class="prettyprint linenums"><code>Person ['__doc__', '__module__', 'name']<br />
Animal ['__class__', '__delattr__', '__dict__', '__doc__', '__format__', '__getattribute__',<br />
'__hash__', '__init__', '__module__', '__new__', '__reduce__', '__reduce_ex__', '__repr__',<br />
'__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', 'name']<br />
</code></pre>
<p>Person类很明显能够看出区别，不继承object对象，只拥有了__doc__ , <strong>module</strong> 和 自己定义的name变量, 也就是说这个类的命名空间只有三个对象可以操作.</p>
<p>Animal类继承了object对象，拥有了好多可操作对象，这些都是类中的高级特性。</p>
<p>对于不太了解python类的同学来说，这些高级特性基本上没用处，但是对于那些要着手写框架或者写大型项目的高手来说，这些特性就比较有用了，比如说tornado里面的异常捕获时就有用到__class__来定位类的名称，还有高度灵活传参数的时候用到__dict__来完成等。</p>
<ul><li><p>python2中不继承object的类叫经典类，继承object的类叫做新式类。</p></li>
<li><p>我们平时写程序时，不妨养成良好的习惯，将object类继承上。</p></li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq445ojq.html">SQL SERVER 中的提示</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq42kk39.html">使用ASP&period;Net WebAPI构建REST服务（一）&mdash;&mdash;简单的示例</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p6od4q.html">java基础-变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rrgxe9.html">json 后台传前台</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o4vdn9.html">CGAL 介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v0lzj8.html">Java文件操作二：File文件的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1w6wj9.html">Android中数据库的操作流程详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j5rdw8.html">MongoDb注意事项</a>
		</li>
						<li><a href="https://www.batexi.com/a/90m4o738.html">Centos7搭建swarm集群</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv16lyyq.html">Ubuntu17&period;04 sudo apt-get update升级错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdwww2z9.html">基于jmeter的性能测试平台（一）分布式jmeter搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o11zm5q.html">Linux服务器评测脚本 中文IO脚本简单易懂</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjg1v39.html">虚拟机 liunx系统以 root 身份登录权限</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25zp0wq.html">WebSphere隐藏版本号教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5ewemq.html">MySql安装和基本管理&amp;amp&semi;mysql语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pz0nnq.html">Is there anyway to discover which ip addresses are connected to the db&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjx6y7q.html">使用jsplumb的一些笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvkd6dq.html">JS求一个数组元素的最小公倍数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyvz3ojq.html">slf4j与logback的结合使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jm53049.html">npm和cnpm（windows）安装步骤</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qllw2keq.html">poj 3264 倍增 ST表</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25gexoq.html">全志A33 lichee 修改开机图片</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e436de9.html">zombodb安装试用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r56lprq.html">快速部署私人git服务--基于docker化Gogs</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwg4px9.html">Git 2&period;x 中git push时遇到 push&period;default 警告的解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/95gzemmq.html">&lbrack;转&rsqb;C&num;程序性能优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2y5p6q.html">django 路由系统中name应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7o2kwg8.html">nginx的启动，停止和重启</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1ry0l48.html">rpm软件包、yum软件仓库、systemd初始化进程</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjkygj9.html">刘志梅201771010115&period;《面向对象程序设计（java）》第二周学习总结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
